#ifndef IMAGEREADER_H
#define IMAGEREADER_H

#include "utils/Cleaner.h"
#include "utils/Color.h"
#include "utils/Error.h"

namespace ImageReader {
    class Image final {
        static void clean(ColorChannel*& c) {
            free(c);
        }

    public:
        Cleaner<ColorChannel*, clean> data;
        unsigned int width;
        unsigned int height;
        unsigned int channels;
        unsigned int bitdepth;
    };

    Error load(Image& image, const char* path);
}

#endif